;*----------------------------------*
;*    >>>Principles of Object<<<    *
;*    >>> Oriented Languages <<<    *
;*                                  *
;*        Reentrant objects         *
;*                                  *
;*           Theo D'Hondt           *
;*  VUB Programming Technology Lab  *
;*              c2001               *
;*        slipified in 2014         *

;*----------------------------------*

(define (<<TABLE>>)
  (define tab '())
  (lambda (op . rest)
    (case op
      ((instantiate)
       (let ((table (<<TABLE>>)))
         (for-each
          (lambda (elt) 
            (table 'put (car elt) (eval (cdr elt))))
          tab)
         table))
      ((get)
       (let* ((key (car rest))
              (entry (assoc key tab)))
         (if entry
             (cdr entry)
             #f)))
      ((put)
       (let* ((key (car rest))
              (entry (assoc key tab))
              (value (cadr rest)))
         (if entry
             (set-cdr! entry value)
             (set! tab (cons (cons key value) tab))))))))

(define-macro VAR
  (lambda (name value)
    `(<<VARS>> 'put ',name ',value)))

(define-macro METHOD
  (lambda (msg args . body)
    `(<<METHODS>> 'put ',msg
      (lambda (<<CONTEXT>> ,@args) ,@body))))

(define-macro CLASS 
  (lambda defs
    `(letrec
         ((<<METHODS>> (<<TABLE>>))
          (<<VARS>> (<<TABLE>>))
          (<<CLASS>>
           (lambda ()
             (define context (<<VARS>> 'instantiate))
             (define (self msg . args)
               (define entry (<<METHODS>> 'get msg))
               (apply entry (cons context args)))
             (context 'put '<<SELF>> self)
             self)))
       ,@defs
       <<CLASS>>)))

(define-macro NEW
  (lambda (class)
    `(,class)))

(define-macro SELF
  (lambda ()
    `(<<CONTEXT>> 'get '<<SELF>>)))

(define-macro SEND
  (lambda (object msg . args)
    `(,object ',msg ,@args)))

(define-macro ? 
  (lambda (name)    
    `(<<CONTEXT>> 'get ' ,name)))

(define-macro ! 
  (lambda (name value)    
    `(<<CONTEXT>> 'put ' ,name ,value)))