                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                   bitheap                   */
                     /*---------------------------------------------*/
//#define SIMPLE

#include "SlipPlatform.h"

#include "SlipBitheap.h"

/*---------------------------------- private constants ---------------------------------*/

//   5
// Sigma 32^i = (32^(5+1) - 1)/(32 - 1) = 1073741823/31 = 34636833
//  i=0

enum { Bitheap_size  = 34636833 };

/*---------------------------------- private variables ---------------------------------*/

static LAM_type Stored_lambda;

static CLR_type Clear_bitheap;

static UNS_type Bitheap[Bitheap_size] = { 0x0 };

/*---------------------------------- private functions ---------------------------------*/

static VOI_type do_(UNS_type);

static VOI_type nibble(UNS_type a,
                       UNS_type n)
  { switch (n)
      { case 0xF:     // 1111  0 1 2 3
          do_(a + 0);
        case 0xE:     // 1110    1 2 3
          do_(a + 1);
          do_(a + 2);
          do_(a + 3);
          return;
        case 0xD:     // 1101  0   2 3
          do_(a + 0);
        case 0xC:     // 1100      2 3
          do_(a + 2);
          do_(a + 3);
          return;
        case 0xB:     // 1011  0 1   3
          do_(a + 0);
        case 0xA:     // 1010    1   3
          do_(a + 1);
          do_(a + 3);
          return;
        case 0x9:     // 1001  0     3
          do_(a + 0);
        case 0x8:     // 1000        3
          do_(a + 3);
          return;
        case 0x7:     // 0111  0 1 2
          do_(a + 0);
        case 0x6:     // 0110    1 2
          do_(a + 1);
          do_(a + 2);
          return;
        case 0x5:     // 0101  0   2
          do_(a + 0);
        case 0x4:     // 0100      2
          do_(a + 2);
          return;
        case 0x3:     // 0011  0 1
          do_(a + 0);
        case 0x2:     // 0010    1
          do_(a + 1);
          return;
        case 0x1:     // 0001  0
          do_(a + 0);
          return;
        case 0x0:
          return; }}

static VOI_type do_(UNS_type a)
  { UNS_type b, l, w;
    if (a >= Bitheap_size)
      Stored_lambda((a - Bitheap_size) << 2);
    else
      if (l = Bitheap[a])
        { if (Clear_bitheap == Clear_Bits)
            Bitheap[a] = 0;
          a = 1 + (a << 5);
          if (w = l & ((1 << 16) - 1))
            { if (b = w & ((1 << 8) - 1))
                { nibble(a +  0, b & ((1 << 4) - 1));
                  nibble(a +  4, b >> 4); }
              if (b = w >> 8)
                { nibble(a +  8, b & ((1 << 4) - 1));
                  nibble(a + 12, b >> 4); }}
          if (w = l >> 16)
            { if (b = w & ((1 << 8) - 1))
                { nibble(a + 16, b & ((1 << 4) - 1));
                  nibble(a + 20, b >> 4); }
              if (b = w >> 8)
                { nibble(a + 24, b & ((1 << 4) - 1));
                  nibble(a + 28, b >> 4); }}}}

static VOI_type set(UNS_type a)
  { UNS_type b, i = 0;
    b = a >> 27; Bitheap[i] |= 1 << b; i = 1 + (i << 5) + b; a &= (1 << 27) - 1;
    b = a >> 22; Bitheap[i] |= 1 << b; i = 1 + (i << 5) + b; a &= (1 << 22) - 1;
    b = a >> 17; Bitheap[i] |= 1 << b; i = 1 + (i << 5) + b; a &= (1 << 17) - 1;
    b = a >> 12; Bitheap[i] |= 1 << b; i = 1 + (i << 5) + b; a &= (1 << 12) - 1;
    b = a >>  7; Bitheap[i] |= 1 << b; i = 1 + (i << 5) + b; a &= (1 <<  7) - 1;
    b = a >>  2; Bitheap[i] |= 1 << b; }

static VOI_type do__(VOI_type (* LAM_type)(UNS_type),
                     CLR_type Clear)
  { UNS_type i0, i1, i2, i3, i4, i5, i6;
    UNS_type l1, l2, l3, l4, l5, l6;
    i0 = 0;
    l1 = Bitheap[i0];
    if (Clear == Clear_Bits) Bitheap[i0] = 0;
    if (l1)
      { i0 = 1 + (i0 << 5);
        for (unsigned b1 = 0; b1 < 32; b1 += 1)
          if (l1 & (1 << b1))
            { i1 = i0 + b1;
              l2 = Bitheap[i1];
              if(Clear == Clear_Bits) Bitheap[i1] = 0;
              if (l2)
                { i1 = 1 + (i1 << 5);
                  for (unsigned b2 = 0; b2 < 32; b2 += 1)
                  if (l2 & (1 << b2))
                    { i2 = i1 + b2;
                      l3 = Bitheap[i2];
                      if(Clear == Clear_Bits) Bitheap[i2] = 0;
                      if (l3)
                        { i2 = 1 + (i2 << 5);
                          for (unsigned b3 = 0; b3 < 32; b3 += 1)
                            if (l3 & (1 << b3))
                              { i3 = i2 + b3;
                                l4 = Bitheap[i3];
                                if(Clear == Clear_Bits) Bitheap[i3] = 0;
                                if (l4)
                                  { i3 = 1 + (i3 << 5);
                                    for (unsigned b4 = 0; b4 < 32; b4 += 1)
                                      if (l4 & (1 << b4))
                                        { i4 = i3 + b4;
                                          l5 = Bitheap[i4];
                                          if(Clear == Clear_Bits) Bitheap[i4] = 0;
                                          if (l5) { i4 = 1 + (i4 << 5);
                                            for (unsigned b5 = 0; b5 < 32; b5 += 1)
                                              if (l5 & (1 << b5))
                                                { i5 = i4 + b5;
                                                  l6 = Bitheap[i5];
                                                  if(Clear == Clear_Bits) Bitheap[i5] = 0;
                                                  if (l6)
                                                    { i5 = 1 + (i5 << 5);
                                                      for (unsigned b6 = 0; b6 < 32; b6 += 1)
                                                        if (l6 & (1 << b6))
                                                          { i6 = i5 + b6;
                                                            Stored_lambda((i6 - Bitheap_size) << 2); }}}}}}}}}}}}}

/*---------------------------------- public functions ----------------------------------*/

#ifdef SIMPLE

VOI_type Bitheap_Do(LAM_type Lambda,
                    CLR_type Clear)
  { UNS_type a, b, i, l;
    for (i = 0; i < (1 << 25); i += 1)
      { l = Bitheap[i];
        if (l)
          { a = i << 7;
            for (b = 0; b < 32; b += 1)
              if (l & (1 << b))
                Lambda(a + (b << 2));
            if (Clear == Clear_Bits)
              Bitheap[i] = 0; }}}

VOI_type Bitheap_Set(UNS_type Address)
  { UNS_type b, i;
    i = Address >> 7;
    b = (Address >> 2) & ((1 << 5) - 1);
    Bitheap[i] |= 1 << b; }

#else

VOI_type Bitheap_Do(LAM_type Lambda,
                    CLR_type Clear)
  { Stored_lambda = Lambda;
    Clear_bitheap = Clear;
    do_(0); }

VOI_type Bitheap_Set(UNS_type Address)
  { set(Address); }

#endif

/*------------------------------------- initialize -------------------------------------*/

VOI_type Bitheap_Initialize(VOI_type)
  { return; }

