                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                    cache                    */
                     /*---------------------------------------------*/

#include "SlipPlatform.h"

#include "SlipGrammar.h"

#include "SlipCache.h"

/*---------------------------------- private constants ---------------------------------*/

enum { Cache_size = 32 };

/*--------------------------------- protected variables --------------------------------*/

static VEC_type Cache_vector_P;

/*---------------------------------- public functions ----------------------------------*/

CHK_type Cache_Make_Chunk_M(UNS_type Size)
  { CHK_type chunk;
    EXP_type chunk_expression;
    if (Size == 0)
      return Unique_Empty_Chunk_P;
    if (Size <= Cache_size)
      { chunk_expression = Cache_vector_P[Size];
        if (!is_UDF(chunk_expression))
          { chunk = chunk_expression;
            chunk_expression = chunk[1];
            chunk[1] = Unique_Undefined;
            Cache_vector_P[Size] = chunk_expression;
            return chunk; }}
    return make_CHK_Z(Size); }

VOI_type Cache_Release_Chunk(CHK_type Chunk)
  { EXP_type chunk_expression;
    UNS_type size,
             index;
    size = size_CHK(Chunk);
    if (size == 0)
      return;
    if (is_CHk(Chunk))
      return;
    if (size > Cache_size)
      return;
    chunk_expression = Cache_vector_P[size];
    Chunk[1] = chunk_expression;
    for (index = 2;
         index <= size;
         index += 1)
      Chunk[index] = Unique_Undefined;
    Cache_vector_P[size] = Chunk; }

/*------------------------------------- initialize -------------------------------------*/

VOI_type Cache_Initialize_M(VOI_type)
  { Cache_vector_P = make_VEC_Z(Cache_size);
    REGISTER(Cache_vector_P); }

