                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                    main                     */
                     /*---------------------------------------------*/

#include "Slip.h"

#include "SlipPlatform.h"
#include "SlipNatives.h"

#include "SlipMain.h"

/*---------------------------------- private constants ---------------------------------*/

enum { Initial_stack_size   = 64,
       Stack_size_increment = 32 };

/*------------------------------------ private types -----------------------------------*/

typedef
  enum { Initialized,
         Not_initialized } Gst_type;

typedef
  enum { Initial_jump     = 0,
         Terminate_jump   = 1 } Jmp_type;

/*---------------------------------- private variables ---------------------------------*/

static Gst_type Global_status = Not_initialized;

static UNS_type Counter;

/*------------------------------- input-output functions -------------------------------*/

BLN_type Main_Close_Input_Port(ADR_type Address)
  { Slip_response response;
    response = Slip_Close(Slip_read_mode,
                          (Slip_address)Address);
    switch (response)
      { case Slip_end_of_stream_response:
        case Slip_invalid_stream_response:
          return FALSE;
        case Slip_success_response:
          return TRUE; }}

BLN_type Main_Close_Output_Port(ADR_type Address)
  { Slip_response response;
    response = Slip_Close(Slip_write_mode,
                          (Slip_address)Address);
    switch (response)
      { case Slip_end_of_stream_response:
        case Slip_invalid_stream_response:
          return FALSE;
        case Slip_success_response:
          return TRUE; }}

ADR_type Main_Open_Input_Port_M(TXT_type Text)
  { Slip_response response;
    ADR_type address;
    response = Slip_Open((Slip_text)Text,
                         Slip_read_mode,
                         (Slip_address *)&address);
    switch (response)
      { case Slip_end_of_stream_response:
        case Slip_invalid_stream_response:
          return VOID;
        case Slip_success_response:
          return address; }}

ADR_type Main_Open_Output_Port_M(TXT_type Text)
  { Slip_response response;
    ADR_type address;
    response = Slip_Open((Slip_text)Text,
                         Slip_write_mode,
                         (Slip_address *)&address);
    switch (response)
      { case Slip_end_of_stream_response:
        case Slip_invalid_stream_response:
          return VOID;
        case Slip_success_response:
          return address; }}

STA_type Main_Read_Char(CHR_type* Char_reference,
                        ADR_type  Address)
  { Slip_response response;
    response = Slip_Read((Slip_char *)Char_reference,
                         (Slip_address)Address);
    switch (response)
      { case Slip_end_of_stream_response:
          return Main_Terminated_Status;
        case Slip_invalid_stream_response:
          return Main_Aborted_Status;
        case Slip_success_response:
          return Main_Successful_Status; }}

STA_type Main_Write_Char(CHR_type Char,
                         ADR_type Address)
  { Slip_response response;
    response = Slip_Write((Slip_char)Char,
                          (Slip_address)Address);
    switch (response)
      { case Slip_end_of_stream_response:
          return Main_Terminated_Status;
        case Slip_invalid_stream_response:
          return Main_Aborted_Status;
        case Slip_success_response:
          return Main_Successful_Status; }}

/*---------------------------------- auxiliary functions -------------------------------*/

UNS_type Main_Count(VOI_type)
  { Counter += 1;
    return Counter; }

VOI_type Main_Error(ERR_type Error,
                    TXT_type Text)
  { Slip_Error((Slip_error)Error,
               (Slip_text)Text);
    Native_Exit(); }

/*----------------------------------- exported functions -------------------------------*/

Slip_void Slip_Eval(Slip_char Text[])
  { Counter = 0;
    if (Global_status == Not_initialized)
      { Global_status = Initialized;
        Native_REP(Text,
                   TRUE); }
    else
      Native_REP(Text,
                 FALSE); }

