                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                  platform                   */
                     /*---------------------------------------------*/

#include <assert.h>
#include <ctype.h>
#include <errno.h>
#include <math.h>
#include <setjmp.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/*------------------------------------ public macros -----------------------------------*/

#define LASTCHAR 255
#define FALSE    0
#define TRUE     !FALSE
#define VOID     0

#define NEWLINE_CHAR '\n'
#define NULL_CHAR    '\0'
#define SPACE_CHAR   ' '

/*----------------------------------- platform macros ----------------------------------*/

#define C_ASSERT   assert                                              /* from assert.h */

#define C_ISPRINT  isprint                                             /* from ctype.h  */

#define C_EDOM     (errno == EDOM)                                     /* from errno.h  */
#define C_ERANGE   (errno == ERANGE)                                   /* from errno.h  */

#define C_JMP_BUF  jmp_buf                                             /* from setjmp.h */
#define C_LONGJMP  longjmp
#define C_SETJMP   setjmp

#define C_PRINTF   printf                                              /* from stdio.h  */
#define C_SNPRINTF snprintf

#define C_ACOS     acos                                                /* from math.h   */
#define C_ASIN     asin
#define C_ATAN     atan
#define C_ATAN2    atan2
#define C_COS      cos
#define C_EXP      exp
#define C_FABS     fabs
#define C_LOG      log
#define C_MODF     modf
#define C_POW      pow
#define C_ROUND    lround
#define C_SIN      sin
#define C_SQRT     sqrt
#define C_TAN      tan
#define C_TRUNC    trunc

#define C_ABORT    abort                                               /* from stdlib.h */
#define C_ABS      abs
#define C_LLABS    llabs
#define C_RAND     rand
#define C_STRTOD   strtod
#define C_STRTOL   strtol

#define C_MEMCPY   memcpy                                              /* from string.h */
#define C_MEMSET   memset
#define C_STRCAT   strcat
#define C_STRCMP   strcmp
#define C_STRCPY   strcpy
#define C_STRLEN   strlen
#define C_STRNCPY  strncpy

#define C_CLOCK    clock()/CLOCKS_PER_SEC                              /* from time.h   */

/*----------------------------------- platform types -----------------------------------*/

typedef          void * ADR_type;                       /* address type                 */
typedef      unsigned   BLN_type;                       /* boolean type                 */
typedef          char   CHR_type;                       /* char type                    */
typedef        double   FLO_type;                       /* long floating type           */
typedef long long int   LNG_type;                       /* long signed integer type     */
typedef    signed int   SGN_type;                       /* signed integer type          */
typedef          char * TXT_type;                       /* text type                    */
typedef  unsigned int   UNS_type;                       /* unsigned integer type        */
typedef          void   VOI_type;                       /* void type                    */

