                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                    stack                    */
                     /*---------------------------------------------*/

#include "SlipPlatform.h"

#include "SlipGrammar.h"

#include "SlipStack.h"

/*---------------------------------- private constants ---------------------------------*/

enum { Initial_stack_size   = 64,
       Stack_size_increment = 32 };

/*---------------------------------- private variables ---------------------------------*/

static UNS_type Stack_size;
static UNS_type Top_of_stack;

/*-------------------------------- protected variables ---------------------------------*/

static VEC_type Stack_vector_P;

/*---------------------------------- public functions ----------------------------------*/

EXP_type Stack_Peek(VOI_type)
  { EXP_type expression;
    expression = Stack_vector_P[Top_of_stack];
    return expression; }

EXP_type Stack_Pop(VOI_type)
  { EXP_type expression;
    expression = Stack_vector_P[Top_of_stack];
    Stack_vector_P[Top_of_stack] = Unique_Undefined;
    Top_of_stack -= 1;
    return expression; }

VOI_type Stack_Push_M(EXP_type Expression)
  { VEC_type stack;
    UNS_type index;
    Top_of_stack += 1;
    Stack_vector_P[Top_of_stack] = Expression;
    if (Top_of_stack == Stack_size)
      { Stack_size += Stack_size_increment;
        stack = make_VEC_Z(Stack_size);
        for (index = 1;
             index <= Top_of_stack;
             index += 1)
          stack[index] = Stack_vector_P[index];
        Stack_vector_P = stack; }}

EXP_type Stack_Swap(EXP_type Expression)
  { EXP_type expression;
    expression = Stack_vector_P[Top_of_stack];
    Stack_vector_P[Top_of_stack] = Expression;
    return expression; }

VOI_type Stack_Reset(VOI_type)
  { for(;
        Top_of_stack > 0;
        Top_of_stack -= 1)
      Stack_vector_P[Top_of_stack] = Unique_Undefined; }

VOI_type Stack_Zap(VOI_type)
  { Stack_vector_P[Top_of_stack] = Unique_Undefined;
    Top_of_stack -= 1; }

/*------------------------------------- initialize -------------------------------------*/

VOI_type Stack_Initialize_M(VOI_type)
  { Stack_vector_P = make_VEC_Z(Initial_stack_size);
    Stack_size = Initial_stack_size;
    Top_of_stack = 0;
    REGISTER(Stack_vector_P); }

