                     /*---------------------------------------------*/
                     /*                  >>>Slip<<<                 */
                     /*                 Theo D'Hondt                */
                     /*          VUB Software Languages Lab         */
                     /*                  (c) 2018                   */
                     /*---------------------------------------------*/
                     /*                final version                */
                     /*---------------------------------------------*/
                     /*                    thread                   */
                     /*---------------------------------------------*/

/*------------------------------------ public macros -----------------------------------*/

#define THREAD_ID(ID)                                                                    \
  static SMI_type Continue_##ID##_smallint = 0

#define THREAD_CONTINUATION(ID)                                                          \
  static VOI_type continue_##ID(VOI_type)

#define THREAD_PROCEDURE(ID)                                                             \
  static VOI_type ID(VOI_type)

#define THREAD_REGISTER(ID)                                                              \
  Continue_##ID##_smallint = Thread_Register(continue_##ID)

#define THREAD_BEGIN_CHUNK(SIGNATURE)                                                    \
  DEFINE_TYPE(SIGNATURE);                                                               \
  BEGIN_CHUNK(SIGNATURE);                                                                \
    DEFINE_SLOT(SMI, __i);                                                               \
    DEFINE_SLOT(EXP, __r);                                                               \
    DEFINE_SLOT(THR, __t)

#define THREAD_END_CHUNK(SIGNATURE)                                                      \
  END_CHUNK(SIGNATURE)

#define THREAD_FRAME_SLOT(SIGNATURE, NAME)                                               \
  SIGNATURE##_type NAME

#define THREAD_GET_RESULT(VALUE, KIND)                                                   \
  (VALUE = (KIND##_type)_Thread_Get_Result())

#define THREAD_KEEP_M(NAME, KIND)                                                        \
  NAME##_thread = (KIND##_type)_Thread_Keep_M()

#define THREAD_PATCH_M(NAME, KIND)                                                       \
  NAME##_thread = (KIND##_type)_Thread_Patch_M(Continue_##NAME##_smallint)

#define THREAD_PEEK(NAME, KIND)                                                          \
  NAME##_thread = (KIND##_type)_Thread_Peek()

#define THREAD_POKE_M(NAME, KIND)                                                        \
  NAME##_thread = (KIND##_type)_Thread_Poke_M(Continue_##NAME##_smallint, KIND##_size)

#define THREAD_PUSH_M(NAME, KIND)                                                        \
  NAME##_thread = (KIND##_type)_Thread_Push_M(Continue_##NAME##_smallint, KIND##_size)

#define THREAD_SET_RESULT(VALUE)                                                         \
  _Thread_Set_Result((EXP_type)VALUE)

#define THREAD_ZAP                                                                       \
 _Thread_Zap()

/*---------------------------------- hidden prototypes ---------------------------------*/

EXP_type _Thread_Get_Result(VOI_type);
THR_type     _Thread_Keep_M(VOI_type);
THR_type       _Thread_Peek(VOI_type);
THR_type    _Thread_Patch_M(SMI_type);
THR_type     _Thread_Poke_M(SMI_type,
                            UNS_type);
THR_type     _Thread_Push_M(SMI_type,
                            UNS_type);
VOI_type _Thread_Set_Result(EXP_type);
VOI_type        _Thread_Zap(VOI_type);

/*---------------------------------- public prototypes ---------------------------------*/

THR_type        Thread_Mark(VOI_type);
VOI_type     Thread_Replace(THR_type);
VOI_type       Thread_Reset(VOI_type);

/*--------------------------------------------------------------------------------------*/

VOI_type      Thread_Loop_M(VOI_type);
SMI_type    Thread_Register(TFN_type);

/*------------------------------------- initialize -------------------------------------*/

VOI_type Thread_Initialize_M(VOI_type);

